--
-- register
-- Specialization for TurnSignalHud
--
-- @author      Karol Gruszczyk (MySQly)
-- @version     v1.0
-- @date        17/01/17
-- @history:    v1.0 - Initial version
--

TurnSignalHud = {}
local TurnSignalHud_directory = g_currentModDirectory

function TurnSignalHud.prerequisitesPresent(specializations)
	return true
end;

function TurnSignalHud:load(xmlFile)
    local iconHeight = g_currentMission.vehicleHudBg.height * 0.13
    local iconWidth = iconHeight / g_screenAspectRatio
    
    local hudWidth = g_currentMission.vehicleHudBg.width
    local hudHeight = g_currentMission.vehicleHudBg.height
    local xLeft = g_currentMission.vehicleHudBg.x + 0.02 * hudWidth
    local xRight = g_currentMission.vehicleHudBg.x + 0.98 * hudWidth - iconWidth
    local y = g_currentMission.vehicleHudBg.y + 0.04 * hudHeight

    TurnSignalHud.leftArrow = Overlay:new("leftArrow", Utils.getFilename("left.dds", TurnSignalHud_directory), xLeft, y, iconWidth, iconHeight)
    TurnSignalHud.rightArrow = Overlay:new("rightArrow", Utils.getFilename("right.dds", TurnSignalHud_directory), xRight, y, iconWidth, iconHeight)
end;

function TurnSignalHud:update(dt)
end;

function TurnSignalHud:keyEvent(unicode, sym, modifier, isDown)
end;

function TurnSignalHud:mouseEvent(posX, posY, isDown, isUp, button)
end;

function TurnSignalHud:delete()
end;

function TurnSignalHud:draw()
    if self.turnLightState ~= nil then
        local mFlickering = Utils.clamp(math.cos(7.0 * g_currentMission.time / 1000) + 0.2, 0, 1);
        if mFlickering == 0 then
            if self.turnLightState == 1 or self.turnLightState == 3 then
                TurnSignalHud.leftArrow:render();
            end;
            if self.turnLightState == 2 or self.turnLightState == 3 then
                TurnSignalHud.rightArrow:render();
            end;
        end;
    end;
end;

